<?php

	include "http.php";

	@ini_set("allow_url_fopen", "1");
	
	global $hbase_path;

	if (!$hbase_path) {
		$hbase_path = dirname(__FILE__);
		if ($hbase_path !== "/") $hbase_path .= "/";
	}
	
	function HBase_get_tmp_path($prefix) {
		
		global $hbase_path;
		return "{$hbase_path}tmp/{$prefix}/";
	}
		
	function HBase_get_http_data($prefix, $url, $method) {
		
		global $hbase_path;

		if (substr($url, 0, 7) != "http://") return;
		
		switch ($method['method']) {
		case "fsockopen":
			$data = fsockopenURL($url);
			break;
			
		case "curl":
			$curl = curl_init();
			
			curl_setopt($curl, CURLOPT_URL, $url);
			curl_setopt($curl, CURLOPT_HEADER, 0);
			
			ob_start();
			curl_exec($curl);
			curl_close($curl);
			$data = ob_get_contents();
			
			ob_end_clean();
			break;
			
		case "wget":
			@mkdir("{$hbase_path}tmp/{$prefix}", 0700);
			$tmpfile = HBase_get_tmp_path($prefix).uniqid("tmp");
			
			exec("{$method[wget_path]} -q '{$url}' -O {$tmpfile}");
			
			if ($fp = fopen($tmpfile, "rb")) {
				while (!feof($fp)) $data .= fread($fp, 1024);
				fclose($fp);
			}
			
			@unlink($tmpfile);
			break;
			
		case "fopen":
			if ($fp = fopen($url, "rb")) {
				while (!feof($fp)) $data .= fread($fp, 1024);
				fclose($fp);
			}
			
			break;
		}
		
		return $data;
	}
	
	function HBase_tmp_accessable() {
		
		global $hbase_path;
		$tmp_path = "{$hbase_path}tmp";
		
		return is_dir($tmp_path) && is_readable($tmp_path) && is_writable($tmp_path);
		
	}
	
	function HBase_get_method() {
		
		$fsockopen_enable = fsockopenCheck();

		$curl_enable = function_exists("curl_init");
		$fopen_url_enable = ini_get("allow_url_fopen");
		
		$whereis_wget = exec("whereis wget");
		$whereis_wget = explode(" ", $whereis_wget);
	
		$wget_path = $whereis_wget[1];
		$wget_excutable = strpos(exec($wget_path), "--help") > 0;
		$wget_tmp_accessable = HBase_tmp_accessable();
		
		$usable =
			$fsockopen_enable || $curl_enable || $fopen_url_enable ||
			($whereis_wget && $wget_excutable && $wget_tmp_accessable);
	
		if (!$usable) {
			
			if (!$fsockopen_enable) {
				$error .= "<br />用不了 fsockopen 函数 ."; 
			}
			
			if (!$curl_enable) {
				$error .= "<br />没有安装 CURL library ."; 
			}
		
			if (!$fopen_url_enable)	{
				$error .= "<br />在fopen函数上，无法使用 URL.";
			}
			 
			if (!$wget_path) {
				$error .= "<br />无法找到 wget 命令.";
			} else if (!$wget_excutable) {
				$error .= "<br />无法执行 wget 命令.";
			} else if (!$wget_tmp_accessable) {
				$error .= "<br />如果要使用 wget 命令，需要重新设定 tmp 文件夹的权限";
			}
	
		} else {
			
			if ($fsockopen_enable) {
				$method = "fsockopen";
			} else if ($fopen_url_enable) {
				$method = "curl";
			} else if ($curl_enable) {
				$method = "fopen";
			} else {
				$method = "wget";
			}
			
		}
		
		return Array(
			"method" => $method,
			"wget_path" => $wget_path,
			"error" => substr($error, 6) // <br />.length
		);
		
	}
?>